' AS351 - HW-Variante 3
' erweiterte HW mit wahlweise
'     RGB-LED (Pin PB0 (Pin 5)=rt und PB2 (Pin 7)=bl) gegen +Ub
' oder
'     rote LED an Pin PB0 (Pin 5) gegen +Ub
' Auswahl erfolgt mit GND an Pin PB4 (Pin 3) => rote LED
' 1Wire-Eingang ist Pin PB3 (Pin 2)
'
$regfile = "attiny13.dat"
$crystal = 1200000       '9,6Mhz /8
$framesize = 18          'um speicher frei zu machen

Declare Sub Sende_lang   'sende langes zeichen
Declare Sub Sende_kurz   'sende kurzes Zeichen
Declare Sub Sende_0      'sende abwechselnd rot und blau oder lang
Declare Sub Sende
Declare Sub Wait16ms
Declare Sub Wait250ms
Declare Sub Wait1s
Declare Sub Wait2s

Enable Interrupts
Config 1wire = Portb.3

Dim I As Byte
Dim Temp As Byte
Dim Vorzeichen As Byte
Dim H As Byte
Dim Z As Byte
Dim E As Byte

Ddrb.0 = 1               'ausgang
Ddrb.2 = 1               'ausgang
Portb.0 = 1              'rot aus
Portb.2 = 0              'blau ein, led blau testen
Gosub Wait1s
Portb.2 = 1              'blau aus

Portb.0 = 0              'rot ein, led rot testen
Gosub Wait1s
Portb.0 = 1              'rot aus

Config Pinb.4 = Input
Portb.4 = 1              'pull-up-R einschalten

Gosub Wait1s

Do
  1wreset
  1wwrite &HCC           'skip rom adressiert im solobetrieb
  1wwrite &H44           'convert t befehl
  Gosub Wait1s           '200ms im 2 drahtbetrieb 800ms im 1drahtbetrieb
  1wreset
  1wwrite &HCC           'skip rom adressiert im solobetrieb
  1wwrite &HBE           'read scratchpad                        '
  Temp = 1wread(1)
  Vorzeichen = 1wread(1)
  1wreset
  Temp = Temp / 2

   If Temp = 0 Then
      Gosub Sende_0      'wenn temp = 0, dann abwechselnd rot und blau
   Else

      If Vorzeichen = 255 Then
         If Pinb.4 = 0 Then Gosub Sende_lang       'sende zuerst ein "minus zeichen"
         Temp = 128 - Temp       'bit8 lschen
      End If

      H = Temp \ 100     'Hunderterstelle
      Z = Temp Mod 100   'Zwischenrechnung
      E = Z Mod 10       'Einerstelle
      Z = Z \ 10         'Zehnerstelle

      Gosub Sende        'sende die ergebnisse

   End If

   Gosub Wait2s          'zusammen mit der letzten Pause
   Gosub Wait2s          '10 Sekunden bis zur nchsten Messung
   Gosub Wait2s
   Gosub Wait2s

Loop

'    Beispiele fr Werte aus Datasheets DS18S20:
'    +85.0      0000 0000 1010 1010      00AAh  170
'    +25.0      0000 0000 0011 0010      0032h   50
'    + 0.5      0000 0000 0000 0001      0001h    1
'      0        0000 0000 0000 0000      0000h    0
'    - 0.5      1111 1111 1111 1111      FFFFh  255
'    -25.0      1111 1111 1100 1110      FFCEh  206
'    -55.0      1111 1111 1001 0010      Ff92h  146

'***************** subroutines ***********************

Sende:
   ' Hunderter
   If H > 0 Then
      While H > 0
         Sende_kurz
      Decr H
      Wend
      Gosub Wait2s
   End If

   ' Zehner
   If Z > 0 Then
      While Z > 0
         Sende_kurz
      Decr Z
      Wend
      Gosub Wait2s
   Else
      If H > 0 Then Sende_lang
      Gosub Wait1s
   End If

   ' Einer
   If E > 0 Then
      While E > 0
         Sende_kurz
      Decr E
      Wend
      Gosub Wait2s
   Else
      Sende_lang
      Gosub Wait1s
   End If

Return

Sende_0:                 'abwechselnd rot und blau
   If Pinb.4 = 1 Then
      For I = 1 To 6
         Portb.0 = 1     'rot aus
         Portb.2 = 0     'blau ein
         Gosub Wait250ms
         Portb.2 = 1     'blau aus
         Portb.0 = 0     'rot ein
         Gosub Wait250ms
      Next
      Portb.0 = 1        'rot aus
   Else
      Gosub Sende_lang
   End If
Return

Sende_lang:              'nur bei roter LED
   Portb.0 = 0           'rot ein
   Gosub Wait2s
   Portb.0 = 1           'rot aus
   Gosub Wait1s
Return

Sende_kurz:
   If Pinb.4 = 1 Then    'RGB-LED
      If Vorzeichen = 255 Then       'nur blau
         Portb.2 = 0
         Gosub Wait250ms
         Portb.2 = 1
      Else               'nur rot
         Portb.0 = 0
         Gosub Wait250ms
         Portb.0 = 1
      End If
   Else                  'nur rote LED
      Portb.0 = 0
      Gosub Wait250ms
      Portb.0 = 1
   End If
   Gosub Wait250ms
Return


' ########################## wait subroutines #####################
' Diese Routinen helfen Strom zu sparen.
' Anstatt nur zu warten wird der Kontroller in den Schlafmodus versetzt.

Wait16ms:
'Watchdog definieren: Nach 16 ms Interrupt auslsen, kein Reset
Wdtcr = &B11010000
Powerdown
Return

Wait250ms:
'Watchdog definieren: Nach 0,25 Sekunden Interrupt auslsen, kein Reset
Wdtcr = &B11010100
Powerdown
Return

Wait1s:
'Watchdog definieren: Nach 1,0 Sekunden Interrupt auslsen, kein Reset
Wdtcr = &B11010110
Powerdown
Return

Wait2s:
'Watchdog definieren: Nach 2,0 Sekunden Interrupt auslsen, kein Reset
Wdtcr = &B11010111
Powerdown
Return

End
'Tabelle fr die Registerwerte:
'
' Wdp3 Wdp2 Wdp1 Wdp0 Number Of Wdt Oscillator Cycles Typical Time -out At  VCC = 5.0V
'    0000 2K (2048) cycles 16 ms
'    0001 4K (4096) cycles 32 ms
'    0010 8K (8192) cycles 64 ms
'    0011 16K (16384) cycles 0.125 s
'    0100 32K (32768) cycles 0.25 s
'    0101 64K (65536) cycles 0.5 s
'    0110 128K (131072) cycles 1.0 s
'    0111 256K (262144) cycles 2.0 s
'    1000 512K (524288) cycles 4.0 s
'    1001 1024K (1048576) cycles 8.0 s

' timsoer@yahoo.de
' modifications by dl2maj, dl2maj@darc.de